package org.sfb441.tradisc;

import javax.swing.text.Position;
import org.w3c.dom.Node;
import java.util.Vector;

/*
 * gar nicht gut: es mssen noch getter und setter her,
 * Instanzen mssen richtig initialisiert werden
 * 
 * Diese Klasse reprsentiert ein XML-Element des Corpus.  
 *  
 * @author wolfgang
 */
public class Location {

	public Node node; // das XML-Element

	// leftmost token: das im XML-Baum am weitesten links
	// und unterhalb von "node" liegende Token-Element. Das
	// Token-Element, d.h. das XML-Element, welches im Corpus
	// Tokens reprsentiert, wird durch Benutzereingabe festgelegt. Nur
	// in Tokens enthaltener Text ist im Applikationsfenster sichtbar.
	// ist "node" selbst ein Token, so ist lmt=this
	public Location lmt = null;

	// Text des Tokens beginnt in der GUI-JTextPane an Position "start"
	public Position start;

	// und ist "len" Zeichen lang
	public int len;

	// XML-Element ist markiert
	public boolean marked;

	// XML-Element ist token (entspr. corpusElement)
	public boolean isToken;

	// vergebenes Tag
	public Tag tag;

	// mgliche Tags
	public Vector tags = null;

	public Location() {
		lmt = null;
		node = null;
	}

	public double complex_score = 0.0;

	// vielleicht kann man die Element2markable-Methode lieber hier rein machen
	public String toString() {
		return Markable.element2markable(node).toString();
	}

}
