package org.sfb441.tradisc.inputformat;

import java.util.Enumeration;
import java.util.Hashtable;

public class CorpusFormat {

	private String tokenTag;

	private String tokenDisplayAttr;

	private Hashtable tokenAttributes;

	private String otherTag;

	private String otherDisplayAttr;

	// TODO zur Zeit: String (name) -> String(value)
	// Vielleicht irgendwann String (name) -> Vector (possible values) machen
	// fr mehr Allgemeinheit, allerdings wahrscheinlich lngere ladezeiten
	private Hashtable otherAttributes;

	public CorpusFormat() {
		tokenTag = "";
		tokenDisplayAttr = "";
		tokenAttributes = new Hashtable();
		otherTag = "";
		otherDisplayAttr = "";
		otherAttributes = new Hashtable();
	}

	public void setTraDiscStandard() {
		tokenTag = "token";
		tokenDisplayAttr = "f";
		otherTag = "other";
		otherDisplayAttr = "f";
	}

	public String getOtherDisplayAttr() {
		return otherDisplayAttr;
	}

	public void setOtherDisplayAttr(String otherDisplayAttr) {
		this.otherDisplayAttr = otherDisplayAttr;
	}

	public String getOtherTag() {
		return otherTag;
	}

	public void setOtherTag(String otherTag) {
		this.otherTag = otherTag;
	}

	public Enumeration getOtherAttributeNames() {
		return otherAttributes.keys();
	}

	public String getOtherAttribute(String name) {
		if (otherAttributes.containsKey(name))
			return (String) otherAttributes.get(name);
		else
			return null;
	}

	public void addOtherAttribute(String name, String value) {
		otherAttributes.put(name, value);
	}

	public void removeOtherAttribute(String name) {
		if (otherAttributes.containsKey(name))
			otherAttributes.remove(name);
	}

	public void clearOtherAttributes() {
		otherAttributes.clear();
	}

	public String getTokenDisplayAttr() {
		return tokenDisplayAttr;
	}

	public void setTokenDisplayAttr(String tokenDisplayAttr) {
		this.tokenDisplayAttr = tokenDisplayAttr;
	}

	public String getTokenTag() {
		return tokenTag;
	}

	public void setTokenTag(String tokenTag) {
		this.tokenTag = tokenTag;
	}

	public Enumeration getTokenAttributeNames() {
		return tokenAttributes.keys();
	}

	public String getTokenAttribute(String name) {
		if (tokenAttributes.containsKey(name))
			return (String) tokenAttributes.get(name);
		else
			return null;
	}

	public void addTokenAttribute(String name, String value) {
		tokenAttributes.put(name, value);
	}

	public void removeTokenAttribute(String name) {
		if (tokenAttributes.containsKey(name))
			tokenAttributes.remove(name);
	}

	public void clearTokenAttributes() {
		tokenAttributes.clear();
	}

}
